<?php
if(!class_exists('HPSort')):
	class HPSort{
		private static $menu_page = '';
		private static $db_post_order = '';
		
		public static function init_admin_menu(){
			self::$menu_page = add_menu_page('Drag and Sort', 'Drag and Sort', 
				'manage_options', 'hpsort_menu',array(__CLASS__,'_hps_mainpage'), HPSORT.'/includes/css/images/drag_hand.png');
			
			//no need for settings at the moment	
			/*add_submenu_page('hpsort_menu', __('Settings'), __('Settings'), 'manage_options',
				'hps_settings', array(__CLASS__, '_hps_settingspage'));*/
			
			add_action('admin_enqueue_scripts', array(__CLASS__,'scripts_init'));
		}
		
		public static function add_ajax_calls(){
			 add_action('wp_ajax_nopriv_hps', array(__CLASS__,'hps_autocomplete_search'));
			 add_action('wp_ajax_hps', array(__CLASS__,'hps_autocomplete_search'));
		}
		
		public static function scripts_init($hook_suffix){
			if($hook_suffix == self::$menu_page) {
				wp_enqueue_script('jquery');
				wp_enqueue_script('jquery_ui_hps', HPSORT.'/includes/js/jquery-ui-1.8.22.hps.js',array('jquery'),'1.0');
				
				wp_register_script('hps', HPSORT.'/includes/js/hps.js');
				wp_enqueue_script('hps');
				
				$HpsObjParams = array(
					'url' => admin_url( 'admin-ajax.php' ),
					/*'allow_duplicates' => get_option('hps_optdup_check')*/
				);
				
				wp_localize_script( 'hps', 'HpsObj', $HpsObjParams);
				
				wp_register_style('jquery_sortable_css', HPSORT.'/includes/css/jquery-ui-1.8.22.hps.css');
				wp_enqueue_style('jquery_sortable_css');
				
				wp_register_style('hps_style', HPSORT.'/includes/css/hps.css');
				wp_enqueue_style('hps_style');
			}	
		}
		
		public static function _hps_mainpage(){
			if(!current_user_can('manage_options')){
				wp_die('You do not have sufficient permissions to access this page.');
			}
			
			if(isset($_POST['hps_postsorder'])){
				self::_save_hps_order($_POST['hps_postsorder']);
			}
			if(isset($_POST['hps_enabled'])){
				update_option('hps_enabled', $_POST['hps_enabled']);
			}
			?>
			<div class="wrap">
				<div class="widget-liquid-left">
				<?php self::_render_latest_box(); ?>
				
				<?php self::_render_placeholder_box(); ?>
				</div>
			</div>
			<?php
		}
		
		// no need for settings at the moment
		/*public static function _hps_settingspage(){
			if(!current_user_can('manage_options')){
				wp_die('You do not have sufficient permissions to access this page.');
			} 
			
			if(isset($_POST['hps_optdup_check'])){
				update_option('hps_optdup_check',$_POST['hps_optdup_check']);
			}
			?>
			<div class="wrap">
				<?php screen_icon('options-general'); ?>
				<h2><?php _e('HomePage Posts - Configurazione'); ?></h2>
				<p>
					<form method="post" action="<?php str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
					<p>
						<label><?php _e('Consenti post duplicati: ') ?></label>
						<input type="hidden" name="hps_optdup_check" value="false" />
						<input type="checkbox" name="hps_optdup_check" 
							<?php if(get_option('hps_optdup_check')=='true') echo('checked'); ?> value="true" />
					</p>
					<?php submit_button(); ?>
					</form>	
				</p>	
			</div>
			<?php
		}*/
		
		private static function _render_placeholder_box(){
			?>
			<div id="widgets-left">
				<div class="widgets-holder-wrap">
					<form id="hps_form" method="post" action="<?php str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
					<div class="hps_head">
						<h1>
							<?php _e('Drag and Sort'); ?>
							<span class="option_enb">
								<input type="hidden" name="hps_enabled" value="false" />
								<?php _e('Enabled '); ?> <input type="checkbox" name="hps_enabled" value="true"
								<?php if(get_option('hps_enabled')==="true") echo('checked'); ?>  />
							</span>
						</h1> 
						
						<span class="option_btn"><?php submit_button(); ?></span> 
					</div>
					<div class="sidebar-name">
						<h3><?php _e('Home Page'); ?></h3>
					</div>
						
					<div class="hps_placeholder" id="hps_placeholder">
						<div class="hps_container" id="hps_container">
							<?php self::_load_hps_order(); ?>
						</div>
					</div>
					<input type="hidden" id="hps_postsorder" name="hps_postsorder" value="<?php echo self::$db_post_order; ?>">
					</form>
				</div>	
			</div>
			<?php
		}
		
		private static function _get_latest_posts(){
			global $post;
			$args = array( 'numberposts' => 10, 'order'=> 'DESC', 'orderby' => 'post_date', 'post_status'=>'publish' );
			$postslist = get_posts( $args );
			foreach ($postslist as $post) { 
				self::_render_side_posts($post);
			}
		}

		//given the post ID returns a title/excerpt/thumbnail box
		private static function _render_post_box($pID){
			$this_post = get_post($pID);
			if(!is_null($this_post)){
				?>
				<li class="dropped" id="li_id_<?php echo $this_post->ID; ?>">
					<div class="hps_post_container" id="hps_post_container">
						<div class="hps_post_title"><a id="hps_boxclose" class="boxclose"></a><?php echo $this_post->post_title; ?></div>
						<div class="hps_post_excerpt"><?php echo $this_post->post_excerpt; ?></div>
						<div class="hps_post_thumb"><?php echo get_the_post_thumbnail($this_post->ID, array(48,48)); ?></div>
					</div>
					<div id="dropped_id" style="display: none"><?php echo $this_post->ID; ?></div>
				</li>
				<?php
			}
		}
		
		private static function _render_side_posts($lpost){
			?>
			<li id="hps_latest_post" class="hps_singlepost">
				<div class="hps_lpost_container">
					<div class="hps_lpost_title" id="hps_lpost_title"><?php echo $lpost->post_title; ?></div>
					<div class="hps_lpost_thumb" id="hps_lpost_thumb"><?php echo get_the_post_thumbnail($lpost->ID, array(36,36)); ?></div>
					<div class="hps_lpost_excerpt" id="hps_lpost_excerpt"><?php echo $lpost->post_excerpt; ?></div>
				</div>
				<div id="hps_singleid" style="display: none"><?php echo $lpost->ID; ?></div> 
			</li>
			<?php
		}
		
		private static function _load_hps_order(){
			$hps_posts = get_option('hps_posts_order');
			if(!empty($hps_posts)){
				self::$db_post_order = implode(',', $hps_posts);
				foreach($hps_posts as $hps_post){
					self::_render_post_box($hps_post);
				}
			} else {
				echo '<div class="place_post">'.__('Drag your posts here').'<div style="padding-top: 5px; font-size: 15px">'
					.__('if you read this message, your homepage is probably empty.').'</div></div>';
			}
		}
		
		private static function _save_hps_order($postsorder){
			if(!empty($postsorder)){
				$arr_order = explode(',',$postsorder);
				update_option('hps_posts_order', $arr_order);
			} else {
				delete_option('hps_posts_order');
			}
		}
		
		private static function _render_latest_box(){
			?>	
			<div class="widget-liquid-right" id="hps_latest_container">
				<div class="widgets-holder-wrap">
					<div id="search_posts" class="search_posts">
						<input size="38" type="text" name="hps_search" id="hps_search_id" placeholder="<?php esc_attr_e( 'Search' ); ?>" />
					</div>
				</div>
				<div class="widgets-holder-wrap">
					<div class="sidebar-name">
						<h3><?php _e('Latest posts'); ?></h3>
					</div>
					<p>
						<div id="latest_posts">
							<?php self::_get_latest_posts(); ?>
						</div>
					</p>
				</div>
			</div>
			
			<?php
		}
		
		public static function hps_autocomplete_search() {
			$args = array(
				's' => $_REQUEST['term'],
				'orderby' => 'post_date',
   				'order' => 'DESC'
			);	
			$posts = get_posts($args);
			
			$search_suggestions = array();
			foreach($posts as $p){
				setup_postdata($p);
				$single_sugg = array();
				$single_sugg['label'] = $p->post_title;
				$single_sugg['excerpt'] = $p->post_excerpt;
				$single_sugg['ID'] = $p->ID;
				
				/* src of post thumbnail */
				$thumb_id = get_post_thumbnail_id($p->ID);
				if(!empty($thumb_id)){
					$thumb_data = wp_get_attachment_image_src($thumb_id);
					$single_sugg['thumb'] = $thumb_data[0];
				}
				/* src of post thumbnail */
				
				$search_suggestions[] = $single_sugg;
			}
			$response = $_GET['callback']."(".json_encode($search_suggestions).")";
			echo $response;
			exit;
		}
		
		//order posts displayed in homepage
		public static function order_hps_posts($orderby){
			$idlist = get_option('hps_posts_order');
			if(!empty($idlist)){
				$ids = implode(',',$idlist);
			} else {
				$ids = array();
			}
			
			return 'FIELD(ID,'.$ids.')';
		}
		
		//pre_get_posts callback 
		public static function get_hps_post($query){
			if(is_home()&&is_main_query()){
				$hps_posts = get_option('hps_posts_order');
				$query->query_vars['orderby'] = 'none';
				$query->query_vars['post__in'] = $hps_posts;
				return;
			}	
		}
	}
endif;