jQuery(document).ready(function($) {
	var elements = $('#hps_postsorder').val().split(',')
	
	$.fn.animateHighlight = function(highlightColor, duration) {
	    var highlightBg = highlightColor || "#FFFF9C";
	    var animateMs = duration || 1500;
	    var originalBg = this.css("backgroundColor");
	    this.stop().css("background-color", highlightBg).animate({backgroundColor: originalBg}, animateMs);
	};
	
	$('#latest_posts li').draggable({
		appendTo: 'body',
		helper: 'clone'
	});
	
	$('#hps_container').droppable({
		activeClass: 'ui-state-default',
		hoverClass: 'ui-state-hover',
		accept: ':not(.ui-sortable-helper)',
		drop: function(event, ui){
			$(this).find('.place_post').remove();
			
			var postID = ui.draggable.find('div#hps_singleid').text(); //get the draggable post id from the right column 
			var postTitle = $.trim(ui.draggable.find('div#hps_lpost_title').text());
			var postExcerpt = $.trim(ui.draggable.find('div#hps_lpost_excerpt').text());
			var postThumb = ui.draggable.find('div#hps_lpost_thumb img').attr('src');
			
			var selected = $('<li class="dropped" id="li_id_'+postID+'"></li>').html(	// and insert it as a hidden field on the left placeholder
				get_post_box(postTitle,postExcerpt,postThumb,postID)).appendTo(this);
			
			check_duplicate(selected); 
		}
	}).sortable({
		sort: function() {
				$(this).removeClass('ui-state-default');
		},
	});
	
	//triggers an event on menu item click and handle it below. don't know if it's the right way of doing it.
	$(document).on('click', 'li.ui-menu-item', function(){
		$(this).trigger('refrEvent');
		$('#hps_search_id').val('');
	});
	
	$(document).on('refrEvent', function(event){
		$('#hps_container').sortable('refresh');
	})

	$(document).on('click', 'a#hps_boxclose', function() {
		var div = $(this).parent().parent().parent();
		$(this).parent().parent().css('background-color', '#605F61').fadeOut('normal', function() {
			div.remove();
			for(var item in elements){
				if(elements[item]===div.find('#dropped_id').text()){
					elements.splice(item,1);
				}
			}
		});
		return false;
	});
	
	// sets the hidden input with post ids
	var post_order = function(){
		var list_elements = new Array();
		$('div#[id*=dropped_id]').each(function() {
			list_elements.push(this.textContent);
		});

		$('input#hps_postsorder').val(list_elements.toString());
	}
	
	$('#hps_form').submit(function(){
		post_order();
	})
	
	// autocomplete search
	var acs_action = 'hps';
	$('#hps_search_id').autocomplete({  
	    source: function(req, response){  
	        $.getJSON(HpsObj.url+'?callback=?&action='+acs_action, req, response);  
	    },  
	    select: function(event, ui) {
	    	var element = $('<li class="dropped" id="li_id_'+ui.item.ID+'">').html(get_post_box(ui.item.label,ui.item.excerpt,ui.item.thumb,ui.item.ID)).appendTo('#hps_container');
	    	check_duplicate(element);
	    	return true;
	    },  
	    minLength: 3
	});
	// autocomplete search
	
	// returns a post box (as a string) to insert in the placeholder
	function get_post_box(title, excerpt, thumb, id){
	return	'<div class="hps_post_container">'+
				'<div class="hps_post_title"><a id="hps_boxclose" class="boxclose"></a>'+title+'</div>'+
					'<div class="hps_post_excerpt">'+excerpt+'</div>'+
					'<div class="hps_post_thumb">'+
						'<img width="48" height="48" src="'+thumb+'" />'+
					'</div>'+
				'</div>'+
			'<div id="dropped_id" style="display: none">'+id+'</div>';
	}
	
	function check_duplicate(element){
		if($.inArray(element.find('#dropped_id').text(), elements)!==-1) {
			element.hide(300, function(){
				element.remove();
			});
			$('#'+element.attr('id')).animateHighlight("#dd0000", 800);	
		} else {
			elements.push(element.find('#dropped_id').text());
		}	
	}
});
